/*
Copyright 2019 caicloud authors. All rights reserved.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/caicloud/cyclone/pkg/apis/cyclone/v1alpha1"
	scheme "github.com/caicloud/cyclone/pkg/k8s/clientset/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ExecutionClustersGetter has a method to return a ExecutionClusterInterface.
// A group's client should implement this interface.
type ExecutionClustersGetter interface {
	ExecutionClusters() ExecutionClusterInterface
}

// ExecutionClusterInterface has methods to work with ExecutionCluster resources.
type ExecutionClusterInterface interface {
	Create(*v1alpha1.ExecutionCluster) (*v1alpha1.ExecutionCluster, error)
	Update(*v1alpha1.ExecutionCluster) (*v1alpha1.ExecutionCluster, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.ExecutionCluster, error)
	List(opts v1.ListOptions) (*v1alpha1.ExecutionClusterList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.ExecutionCluster, err error)
	ExecutionClusterExpansion
}

// executionClusters implements ExecutionClusterInterface
type executionClusters struct {
	client rest.Interface
}

// newExecutionClusters returns a ExecutionClusters
func newExecutionClusters(c *CycloneV1alpha1Client) *executionClusters {
	return &executionClusters{
		client: c.RESTClient(),
	}
}

// Get takes name of the executionCluster, and returns the corresponding executionCluster object, and an error if there is any.
func (c *executionClusters) Get(name string, options v1.GetOptions) (result *v1alpha1.ExecutionCluster, err error) {
	result = &v1alpha1.ExecutionCluster{}
	err = c.client.Get().
		Resource("executionclusters").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ExecutionClusters that match those selectors.
func (c *executionClusters) List(opts v1.ListOptions) (result *v1alpha1.ExecutionClusterList, err error) {
	result = &v1alpha1.ExecutionClusterList{}
	err = c.client.Get().
		Resource("executionclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested executionClusters.
func (c *executionClusters) Watch(opts v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Resource("executionclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a executionCluster and creates it.  Returns the server's representation of the executionCluster, and an error, if there is any.
func (c *executionClusters) Create(executionCluster *v1alpha1.ExecutionCluster) (result *v1alpha1.ExecutionCluster, err error) {
	result = &v1alpha1.ExecutionCluster{}
	err = c.client.Post().
		Resource("executionclusters").
		Body(executionCluster).
		Do().
		Into(result)
	return
}

// Update takes the representation of a executionCluster and updates it. Returns the server's representation of the executionCluster, and an error, if there is any.
func (c *executionClusters) Update(executionCluster *v1alpha1.ExecutionCluster) (result *v1alpha1.ExecutionCluster, err error) {
	result = &v1alpha1.ExecutionCluster{}
	err = c.client.Put().
		Resource("executionclusters").
		Name(executionCluster.Name).
		Body(executionCluster).
		Do().
		Into(result)
	return
}

// Delete takes name of the executionCluster and deletes it. Returns an error if one occurs.
func (c *executionClusters) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("executionclusters").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *executionClusters) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	return c.client.Delete().
		Resource("executionclusters").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched executionCluster.
func (c *executionClusters) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.ExecutionCluster, err error) {
	result = &v1alpha1.ExecutionCluster{}
	err = c.client.Patch(pt).
		Resource("executionclusters").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
